# range_header_parser

![Travis-CI status](https://api.travis-ci.org/wetransfer/range_header_parser.svg?branch=master)

Parse `Range:` HTTP headers, and returns an Array of Ruby ranges. The ranges are guaranteed to be:

* positive
* inclusive
* of at least 1 byte

Use it like so:

    if env['HTTP_RANGE']
      ranges = RangeHeaderParser.parse(env['HTTP_RANGE], size_of_resource)
    end

Adjacent ranges will be combined. Note that returning multiple ranges requires a multipart/byteranges
response, and you might need some special machinery to be able to generate it.

## Contributing to range_header_parser
 
* Check out the latest master to make sure the feature hasn't been implemented or the bug hasn't been fixed yet.
* Check out the issue tracker to make sure someone already hasn't requested it and/or contributed it.
* Fork the project.
* Start a feature/bugfix branch.
* Commit and push until you are happy with your contribution.
* Make sure to add tests for it. This is important so I don't break it in a future version unintentionally.
* Please try not to mess with the Rakefile, version, or history. If you want to have your own version, or is otherwise necessary, that is fine, but please isolate to its own commit so I can cherry-pick around it.

## Copyright

Copyright (c) 2015 WeTransfer. See LICENSE.txt for
further details.

